#include "kernel.h"
#include "kernel_id.h"
#include "ecrobot_interface.h"
#include "stdio.h"
#include "../leJOS_EV3/src/ev3/ninja/led.h"

#define LOOP1(ID,End) if(ID==1){a++;}else if(ID==2){b++;}else if(ID==3){c++;} for(int k=0; k<End; k++){j|=j<<1;}
#define LOOP2(ID,End) if(ID==1){a++;}else if(ID==2){b++;}else if(ID==3){c++;} for(int l=0; l<End; l++){j|=j<<1;}
#define getTime() current_time = systick_get_ms()-first_start;

DeclareTask(Task1);
DeclareTask(Task2);
DeclareTask(Task3);
DeclareCounter(SysTimerCnt);

void user_1ms_isr_type2(void){
    (void)SignalCounter(SysTimerCnt);
}

static U32 current_time;
static U32 first_start = 0;
static int j = 100;
static int End;
static int a,b,c = 0;

TASK(Task1)
{ 
	led_set(LED_BOTH, LED_GREEN);
  getTime();
  printf("Task 1(%i) start at %i.\n\r",a,current_time);
  LOOP1(1,562*500);
  led_set(LED_BOTH, LED_GREEN);
  LOOP1(1,562*500);
  led_set(LED_BOTH, LED_GREEN);
  LOOP1(1,562*500);
  led_set(LED_BOTH, LED_GREEN);
  LOOP1(1,562*500);
  led_set(LED_BOTH, LED_GREEN);
  getTime();
  printf("Task 1(%i) end at %i.\n\r",a,current_time);
  led_set(LED_BOTH, LED_BLACK);
  TerminateTask();
}

TASK(Task2)
{
  led_set(LED_BOTH, LED_ORANGE);
  getTime();
  printf("Task 2(%i) start at %i.\n\r",b,current_time);
  LOOP1(2,562*500);
  led_set(LED_BOTH, LED_ORANGE);
  LOOP1(2,562*500);
  led_set(LED_BOTH, LED_ORANGE);
  LOOP1(2,562*500);
  led_set(LED_BOTH, LED_ORANGE);
  LOOP1(2,562*500);
  led_set(LED_BOTH, LED_ORANGE);
  getTime();
  printf("Task 2(%i) end at %i.\n\r",b,current_time);
  led_set(LED_BOTH, LED_BLACK);
  TerminateTask();
}

TASK(Task3)
{
  led_set(LED_BOTH, LED_RED);
  getTime();
  printf("Task 3(%i) start at %i.\n\r",c,current_time);
  LOOP1(3,562*500);
  led_set(LED_BOTH, LED_RED);
  LOOP1(3,562*500);
  led_set(LED_BOTH, LED_RED);
  LOOP1(3,562*500);
  led_set(LED_BOTH, LED_RED);
  LOOP1(3,562*500);
  led_set(LED_BOTH, LED_RED);
  getTime();
  printf("Task 3(%i) end at %i.\n\r",c,current_time);
  led_set(LED_BOTH, LED_BLACK);
  TerminateTask();
}


